package betterwithmods.common.blocks;

import betterwithmods.api.block.IMultiVariants;
import betterwithmods.common.BWOreDictionary;
import net.minecraft.block.Block;
import net.minecraft.block.BlockSkull;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.item.ItemStack;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import betterwithmods.common.blocks.BlockStickBase.Connection;

public class BlockCandleHolder extends BlockStickBase implements IMultiVariants {

    public BlockCandleHolder() {
        super(Material.field_151573_f);
    }

    @Override
    public boolean func_176196_c(World worldIn, BlockPos pos) {
        return worldIn.isSideSolid(pos.func_177977_b(), EnumFacing.UP);
    }

    @Override
    public IBlockState getConnections(IBlockState state, IBlockAccess world, BlockPos pos) {
        IBlockState above = world.func_180495_p(pos.func_177984_a());
        Block block = above.func_177230_c();
        ItemStack stack = new ItemStack(block, 1, block.func_176201_c(above));

        if (block == this) {
            return state.func_177226_a(CONNECTION, Connection.CONNECTED);
        } else if (BWOreDictionary.isOre(stack, "blockCandle")) {
            return state.func_177226_a(CONNECTION, Connection.CANDLE);
        } else if (block instanceof BlockSkull) {
            return state.func_177226_a(CONNECTION, Connection.SKULL);
        }
        return state;
    }

    @Override
    public double getHeight(IBlockState state) {
        Connection c = state.func_177229_b(CONNECTION);
        return c == Connection.DISCONNECTED ? 14d / 16d : 1;
    }

    @Override
    public String[] getVariants() {
        return new String[]{"connection=disconnected,ground=true"};
    }

}
