package betterwithmods.common.entity;

import net.minecraft.block.Block;
import net.minecraft.block.BlockFalling;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.MoverType;
import net.minecraft.entity.item.EntityFallingBlock;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.network.datasync.DataParameter;
import net.minecraft.network.datasync.DataSerializers;
import net.minecraft.network.datasync.EntityDataManager;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.World;

import javax.annotation.Nullable;

public class EntityFallingGourd extends EntityFallingBlock {
    private static final DataParameter<Integer> FALLBLOCK = EntityDataManager.func_187226_a(EntityFallingGourd.class, DataSerializers.field_187192_b);
    private ItemStack seedStack = ItemStack.field_190927_a;

    @SuppressWarnings("unused")
    public EntityFallingGourd(World worldIn) {
        super(worldIn);
    }

    public EntityFallingGourd(World worldIn, double x, double y, double z, IBlockState fallingBlockState) {
        super(worldIn, x, y, z, fallingBlockState);
        setBlock(fallingBlockState);
    }

    @Override
    public void func_70071_h_() {
        IBlockState fallblock = func_175131_l();
        Block block = fallblock.func_177230_c();
        if (fallblock.func_185904_a() == Material.field_151579_a) {
            this.func_70106_y();
        } else {
            this.field_70169_q = this.field_70165_t;
            this.field_70167_r = this.field_70163_u;
            this.field_70166_s = this.field_70161_v;
            BlockPos blockpos1;
            if (this.field_145812_b++ == 0) {
                blockpos1 = new BlockPos(this);
                if (this.func_130014_f_().func_180495_p(blockpos1).func_177230_c() == block) {
                    this.func_130014_f_().func_175698_g(blockpos1);
                } else if (!this.func_130014_f_().field_72995_K) {
                    this.func_70106_y();
                    return;
                }
            }

            if (!this.func_189652_ae()) {
                this.field_70181_x -= 0.03999999910593033D;
            }

            this.func_70091_d(MoverType.SELF, this.field_70159_w, this.field_70181_x, this.field_70179_y);
            this.field_70159_w *= 0.9800000190734863D;
            this.field_70181_x *= 0.9800000190734863D;
            this.field_70179_y *= 0.9800000190734863D;
            if (!this.func_130014_f_().field_72995_K) {
                blockpos1 = new BlockPos(this);
                if (this.field_70122_E) {
                    IBlockState iblockstate = this.func_130014_f_().func_180495_p(blockpos1);
                    if (this.func_130014_f_().func_175623_d(new BlockPos(this.field_70165_t, this.field_70163_u - 0.009999999776482582D, this.field_70161_v)) && BlockFalling.func_185759_i(this.func_130014_f_().func_180495_p(new BlockPos(this.field_70165_t, this.field_70163_u - 0.009999999776482582D, this.field_70161_v)))) {
                        this.field_70122_E = false;
                        return;
                    }

                    this.field_70159_w *= 0.699999988079071D;
                    this.field_70179_y *= 0.699999988079071D;
                    this.field_70181_x *= -0.5D;
                    if (iblockstate.func_177230_c() != Blocks.field_180384_M) {
                        if (this.func_130014_f_().func_190527_a(block, blockpos1, true, EnumFacing.UP, null) && !BlockFalling.func_185759_i(this.func_130014_f_().func_180495_p(blockpos1.func_177977_b())) && (10 + field_70146_Z.nextInt(7)) > this.field_145812_b && this.func_130014_f_().func_180501_a(blockpos1, fallblock, 3)) {
                            this.func_70106_y();
                            if (block instanceof BlockFalling) {
                                ((BlockFalling) block).func_176502_a_(this.func_130014_f_(), blockpos1, fallblock, iblockstate);
                            }
                        } else {
                            this.shatter();
                        }
                    }
                } else if (this.field_145812_b > 100 && !this.func_130014_f_().field_72995_K && (blockpos1.func_177956_o() < 1 || blockpos1.func_177956_o() > 256) || this.field_145812_b > 600) {
                    this.shatter();
                }
            }
        }
    }

    @Override
    public void func_180430_e(float p_fall_1_, float p_fall_2_) {
        //TODO: I guess this should deal like half a heart of damage maybe
    }

    public void shatter() {
        //TODO: This needs to make a splash sound
        if (!func_130014_f_().field_72995_K) {
            IBlockState fallblock = func_175131_l();
            if (fallblock != null)
                func_130014_f_().func_175718_b(2001, new BlockPos(this), Block.func_176210_f(fallblock));

            if (!seedStack.func_190926_b()) {
                ItemStack seeds = seedStack.func_77946_l();
                seeds.func_190920_e(field_70146_Z.nextInt(3) + 1);
                if (this.field_145813_c && this.func_130014_f_().func_82736_K().func_82766_b("doEntityDrops")) {
                    this.func_70099_a(seeds, 0.0F);
                }
            }
        }

        this.func_70106_y();
    }

    @Nullable
    @Override
    public IBlockState func_175131_l() {
        return Block.func_176220_d(field_70180_af.func_187225_a(FALLBLOCK));
    }

    public void setBlock(IBlockState blockstate) {
        field_70180_af.func_187227_b(FALLBLOCK, Block.func_176210_f(blockstate));
    }

    public ItemStack getSeedStack() {
        return seedStack;
    }

    public void setSeedStack(ItemStack stack) {
        seedStack = stack;
    }

    @Override
    protected void func_70088_a() {
        super.func_70088_a();
        field_70180_af.func_187214_a(FALLBLOCK, 0);
    }

    @Override
    public void func_70037_a(NBTTagCompound p_readEntityFromNBT_1_) {
        super.func_70037_a(p_readEntityFromNBT_1_);
        IBlockState fallblock;
        int i = p_readEntityFromNBT_1_.func_74771_c("Data") & 255;
        if (p_readEntityFromNBT_1_.func_150297_b("Block", 8)) {
            fallblock = Block.func_149684_b(p_readEntityFromNBT_1_.func_74779_i("Block")).func_176203_a(i);
        } else if (p_readEntityFromNBT_1_.func_150297_b("TileID", 99)) {
            fallblock = Block.func_149729_e(p_readEntityFromNBT_1_.func_74762_e("TileID")).func_176203_a(i);
        } else {
            fallblock = Block.func_149729_e(p_readEntityFromNBT_1_.func_74771_c("Tile") & 255).func_176203_a(i);
        }
        setBlock(fallblock);
    }

    @Override
    public void func_70014_b(NBTTagCompound p_writeEntityToNBT_1_) {
        super.func_70014_b(p_writeEntityToNBT_1_);
        IBlockState fallblock = func_175131_l();
        Block block = fallblock != null ? fallblock.func_177230_c() : Blocks.field_150350_a;
        ResourceLocation resourcelocation = Block.field_149771_c.func_177774_c(block);
        p_writeEntityToNBT_1_.func_74778_a("Block", resourcelocation == null ? "" : resourcelocation.toString());
        p_writeEntityToNBT_1_.func_74774_a("Data", (byte) block.func_176201_c(fallblock));
    }
}
