package betterwithmods.common.registry;

import betterwithmods.BWMod;
import net.minecraft.block.Block;
import net.minecraft.item.ItemStack;
import net.minecraftforge.oredict.OreDictionary;

import java.util.*;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * Purpose:
 *
 * @author primetoxinz
 * @version 11/13/16
 */
public class HopperFilters {
    public static final HashMap<Integer, Predicate<ItemStack>> filters = new HashMap<>();
    public static final HashMap<ItemStack, Integer> filterTypes = new HashMap<>();

    public static boolean containsStack(Set<ItemStack> set, ItemStack stack) {
        Optional<ItemStack> found = set.stream().filter(s -> s.func_77969_a(stack)).findFirst();
        return found.isPresent();
    }

    public static void addFilter(ItemStack stack, Set<ItemStack> allowedItems) {
        addFilter(filters.size() + 1, stack, s -> containsStack(allowedItems, s));
    }

    public static void addFilter(int type, Block block, int meta, Predicate<ItemStack> allowed) {
        addFilter(type, new ItemStack(block, 1, meta), allowed);
    }

    public static void addFilter(int type, ItemStack filter, Predicate<ItemStack> allowed) {
        if (filterTypes.containsKey(filter)) {
            throw new IllegalArgumentException("Filter " + filter.func_82833_r() + "For Type " + type + " Already exists");
        }
        if (filters.containsKey(type)) {
            throw new IllegalArgumentException("Filter " + type + " Already exists");
        }
        BWMod.logger.info("Adding Filter " + filter.func_82833_r() + "," + type);
        filterTypes.put(filter, type);
        filters.put(type, allowed);
    }

    public static List<ItemStack> getFilter(int type) {
        return filterTypes.entrySet().stream().filter(entry -> entry.getValue() == type).map(Map.Entry::getKey).collect(Collectors.toList());
    }

    public static Predicate<ItemStack> getAllowedItems(int type) {
        return filters.get(type);
    }

    public static int getFilterType(ItemStack filter) {
        Optional<Integer> type = filterTypes.entrySet().stream().
                filter(e -> e.getKey().func_77973_b() == filter.func_77973_b() && (e.getKey().func_77960_j() == filter.func_77960_j() || e.getKey().func_77960_j() == OreDictionary.WILDCARD_VALUE))
                .map(Map.Entry::getValue).findAny();
        return type.orElse(0);
    }
}
